--[[
Ni Inventory Monitor (NIM) (version 1.0 - beta)

NIM currently tracks all characters (after logging in the first time) and will display
tooltips for all crafting traits set to track. NIM is quite functional for that purpose.
It will remember junked items and add new items to the junk list if it matches. It will
auto-junk items based on criteria in the settings.

TURN OFF ALL JUNK AUTO-SELLERS until you are comfortable with the behavior!


Future updates:
- Due to ESO API limitations, NIM cannot track traits in loot containers. Yet.
- NIM currently remembers all items in bank and inventories, but there is no user
interface to search or display, yet.
- Hooks exist for language translations, but this is not yet implemented pending final
strings and translation.

This code is designed for end users, and should work fine on all ESO installations. Because I
don't want NIM forked while it's in development, the code has been compressed and stripped.

This software and a list of approved mirrors are listed at the official site,
http://knights-who-say-ni.com/ESO

Rants and praise can be sent to @Vuelhering on the North American megaserver.  All threats
and requests must be accompanied with plenty of in-game gold to be taken seriously. :-)

Copyright 2014, Vuelhering, Knights who say Ni (ESO NA server), <vuelhering@gmail.com>
Permission granted for use, modification, and distribution provided:
1. Any distribution includes the ORIGINAL DISTRIBUTION IN ITS ENTIRETY, or a working URL to freely get the ENTIRE ORIGINAL DISTRIBUTION is clearly listed in the documentation or top of each file. (Listing http://knights-who-say-ni.com/ESO in each file will suffice.)
2. This entire copyright and distribution notice is included and incorporated.
3. Any modified distributions clearly mark any changes from the original.
4. Any modified distributions MUST NOT IMPLY in any way that it is an official upgrade version of the software. If you want your changes in the official distribution, contact (vuelhering-at-gmail) and it might get included.
5. No fee may be required for any distribution of this software (modified or original). "Fees" include valuable information such as personal details, phone numbers, installing spy software, etc., but does not include website cookies or tracking information. Note: Downloads CANNOT REQUIRE installation of non-standard software to distribute this software. Optional installation software (such as AddOn updaters) is allowed provided the Ni Addon can be downloaded normally.
6. No warranty is given or implied. No claims of fitness for purpose is given or implied. Use at your own risk. 
]]--
local g={}local e="Ni-InvMonitor"local k="Ni Inventory Monitor"local T="NIM"local W="/nim"local b,U=1,0
local r="_unknown"local i,o={},{}local s=1
local f=false
local h=true
local O=ITEM_QUALITY_MAGIC
local N=false
local R=true
local u=false
local I=ITEM_QUALITY_MAGIC
local v=false
local S=false
if s>0 then
craft={}inv={}else
local e={}local e={}end
local A={[ITEM_QUALITY_NORMAL]="Normal",[ITEM_QUALITY_MAGIC]="Magic",[ITEM_QUALITY_ARCANE]="Arcane",[ITEM_QUALITY_ARTIFACT]="Artifact",}local c={[CRAFTING_TYPE_BLACKSMITHING]="Blacksmith",[CRAFTING_TYPE_CLOTHIER]="Clothier",[CRAFTING_TYPE_WOODWORKING]="Woodworker",}local E={}local a=LibStub:GetLibrary("LibAddonMenu-1.0")local l
local P={["showloot"]=false,["gray"]=true,["trophy"]=ITEM_QUALITY_MAGIC,["lure"]=false,["rarestyles"]=true,["intricate"]=false,["keep"]=ITEM_QUALITY_MAGIC,["debug"]=0,}local n={}local L={["en"]={["usage"]=[[ commands:
	/nim loot - show loot drops
	/nim gray/lure - toggle autojunking of item types
	/nim rarestyles - toggle keeping items of rare styles (Daedric, etc.) and style comps
	/nim intricate - toggle keeping intricate items for deconstruction
	/nim white/green/blue/purple - don't autojunk items at this quality+
	/nim status - list settings
	/nim db - list junk items
	/nim reset - reset junk db for ALL characters
	/nim resetall - reset junk, bank, inventories for ALL characters
	/nim default - reset defaults for this character
	]],["char"]="Autojunk items for ",["cleared"]="Autojunk db cleared.",["notfound"]="No Autojunk items found for ",["firstrun1"]="|cD8C1FF"..k.." ("..T..") FIRST-RUN WARNING:".."|r",["firstrun2"]="|cD8C1FF"..T.." manipulates junk status of items. Turning off automated junk-selling addons is recommended.".."|r",["startup"]=T..": Use menu for options, or "..W.." for command line",["on"]=" is on",["off"]=" is off",["showloot"]="Show group loot",["rarestyles"]="Keep rare styles",["intricate"]="Keep intricate items",["gray"]="Autojunking of gray items",["trophy"]="Trophy threshold",["lure"]="Autojunking of lures",["debug"]="Debug",},}local F={[ITEM_TRAIT_TYPE_ARMOR_STURDY]=1,[ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE]=2,[ITEM_TRAIT_TYPE_ARMOR_REINFORCED]=3,[ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED]=4,[ITEM_TRAIT_TYPE_ARMOR_TRAINING]=5,[ITEM_TRAIT_TYPE_ARMOR_INFUSED]=6,[ITEM_TRAIT_TYPE_ARMOR_EXPLORATION]=7,[ITEM_TRAIT_TYPE_ARMOR_DIVINES]=8,[ITEM_TRAIT_TYPE_WEAPON_POWERED]=1,[ITEM_TRAIT_TYPE_WEAPON_CHARGED]=2,[ITEM_TRAIT_TYPE_WEAPON_PRECISE]=3,[ITEM_TRAIT_TYPE_WEAPON_INFUSED]=4,[ITEM_TRAIT_TYPE_WEAPON_DEFENDING]=5,[ITEM_TRAIT_TYPE_WEAPON_TRAINING]=6,[ITEM_TRAIT_TYPE_WEAPON_SHARPENED]=7,[ITEM_TRAIT_TYPE_WEAPON_WEIGHTED]=8,}local Q={[WEAPONTYPE_AXE]=1,[WEAPONTYPE_HAMMER]=2,[WEAPONTYPE_SWORD]=3,[WEAPONTYPE_TWO_HANDED_AXE]=4,[WEAPONTYPE_TWO_HANDED_HAMMER]=5,[WEAPONTYPE_TWO_HANDED_SWORD]=6,[WEAPONTYPE_DAGGER]=7,[WEAPONTYPE_BOW]=1,[WEAPONTYPE_FIRE_STAFF]=2,[WEAPONTYPE_FROST_STAFF]=3,[WEAPONTYPE_LIGHTNING_STAFF]=4,[WEAPONTYPE_HEALING_STAFF]=5,[WEAPONTYPE_SHIELD]=6,}local y={[ARMORTYPE_LIGHT]={[EQUIP_TYPE_CHEST]=1,[EQUIP_TYPE_COSTUME]=0,[EQUIP_TYPE_FEET]=2,[EQUIP_TYPE_HAND]=3,[EQUIP_TYPE_HEAD]=4,[EQUIP_TYPE_INVALID]=0,[EQUIP_TYPE_LEGS]=5,[EQUIP_TYPE_MAIN_HAND]=0,[EQUIP_TYPE_NECK]=0,[EQUIP_TYPE_OFF_HAND]=0,[EQUIP_TYPE_ONE_HAND]=0,[EQUIP_TYPE_RING]=0,[EQUIP_TYPE_SHOULDERS]=6,[EQUIP_TYPE_TWO_HAND]=0,[EQUIP_TYPE_WAIST]=7,},[ARMORTYPE_MEDIUM]={[EQUIP_TYPE_CHEST]=8,[EQUIP_TYPE_COSTUME]=0,[EQUIP_TYPE_FEET]=9,[EQUIP_TYPE_HAND]=10,[EQUIP_TYPE_HEAD]=11,[EQUIP_TYPE_INVALID]=0,[EQUIP_TYPE_LEGS]=12,[EQUIP_TYPE_MAIN_HAND]=0,[EQUIP_TYPE_NECK]=0,[EQUIP_TYPE_OFF_HAND]=0,[EQUIP_TYPE_ONE_HAND]=0,[EQUIP_TYPE_RING]=0,[EQUIP_TYPE_SHOULDERS]=13,[EQUIP_TYPE_TWO_HAND]=0,[EQUIP_TYPE_WAIST]=14,},[ARMORTYPE_HEAVY]={[EQUIP_TYPE_CHEST]=8,[EQUIP_TYPE_COSTUME]=0,[EQUIP_TYPE_FEET]=9,[EQUIP_TYPE_HAND]=10,[EQUIP_TYPE_HEAD]=11,[EQUIP_TYPE_INVALID]=0,[EQUIP_TYPE_LEGS]=12,[EQUIP_TYPE_MAIN_HAND]=0,[EQUIP_TYPE_NECK]=0,[EQUIP_TYPE_OFF_HAND]=0,[EQUIP_TYPE_ONE_HAND]=0,[EQUIP_TYPE_RING]=0,[EQUIP_TYPE_SHOULDERS]=13,[EQUIP_TYPE_TWO_HAND]=0,[EQUIP_TYPE_WAIST]=14,},}local function t(e)if s>0 then
d(T..": "..e)end
end
local function _(e)if s>1 then
d(T..": "..e)end
end
local function M(t,e)if s==0 then
return
end
if t then
d(T..": "..e..n.on)else
d(T..": "..e..n.off)end
end
local function Y()o.showloot=f
o.gray=h
o.trophy=O
o.lure=N
o.rarestyles=R
o.intricate=u
o.debug=s
o.keep=I
end
local function C()f=o.showloot
h=o.gray
R=o.rarestyles
u=o.intricate
N=o.lure
O=o.trophy
I=o.keep
s=o.debug
end
local function m(e)return e:gsub("%^%a+","")end
local function G(n,o)local e=m(zo_strformat(SI_TOOLTIP_ITEM_NAME,GetItemName(n,o)))local n=GetItemType(n,o)local o="setting "..e.." to junk"if n==ITEMTYPE_ARMOR
or n==ITEMTYPE_CONTAINER
or n==ITEMTYPE_WEAPON then
o=o.." (armor/weap - not adding to db)"else
if i.db[e]==nil then
i.db[e]={}end
t(o)i.db[e][r]=true
end
end
local function D()local n=BAG_BANK
local t,e=GetBagInfo(n)for e=0,e-1 do
local t={GetItemInfo(n,e)}if t[2]~=0 then
inv.db._bank[e]=t
inv.db._bank[e][9]=GetItemLink(n,e,LINK_STYLE_DEFAULT)else
inv.db._bank[e]={[2]=0}inv.db._bank[e][9]=""end
end
end
local function p(e,n)if e~=BAG_WORN and e~=BAG_BACKPACK and e~=BAG_BANK then
return
end
local t,t=GetBagInfo(e)local t
local o={GetItemInfo(e,n)}if e==BAG_BANK then
t=inv.db._bank
else
t=inv.db[r][e]if IsItemJunk(e,n)then
G(e,n)end
end
if o[2]~=0 then
t[n]=o
t[n][9]=GetItemLink(e,n,LINK_STYLE_DEFAULT)else
t[n]={[2]=0}t[n][9]=""end
_("updating "..t[n][9].." stack of "..o[2])end
local function H()for n,e in pairs{BAG_WORN,BAG_BACKPACK}do
local t,n=GetBagInfo(e)for n=0,n-1 do
p(e,n)end
end
D()end
local function D(r,t)local e=0
local n=0
local o=0
local i={}local l={}local d=GetItemLink(r,t,LINK_STYLE_DEFAULT)local E={GetItemInfo(r,t)}local a=GetItemType(r,t)repeat
if a==ITEMTYPE_ARMOR then
e=GetItemArmorType(d)if e==0 then
break
end
o=y[e][E[6]]if e==ARMORTYPE_HEAVY then
n=CRAFTING_TYPE_BLACKSMITHING
elseif e==ARMORTYPE_LIGHT or e==ARMORTYPE_MEDIUM then
n=CRAFTING_TYPE_CLOTHIER
end
elseif a==ITEMTYPE_WEAPON then
e=GetItemWeaponType(d)if e==0 then
break
end
o=Q[e]if e==WEAPONTYPE_AXE
or e==WEAPONTYPE_DAGGER
or e==WEAPONTYPE_HAMMER
or e==WEAPONTYPE_SWORD
or e==WEAPONTYPE_TWO_HANDED_AXE
or e==WEAPONTYPE_TWO_HANDED_SWORD
or e==WEAPONTYPE_TWO_HANDED_HAMMER then
n=CRAFTING_TYPE_BLACKSMITHING
elseif e==WEAPONTYPE_BOW
or e==WEAPONTYPE_FIRE_STAFF
or e==WEAPONTYPE_FROST_STAFF
or e==WEAPONTYPE_LIGHTNING_STAFF
or e==WEAPONTYPE_HEALING_STAFF
or e==WEAPONTYPE_SHIELD then
n=CRAFTING_TYPE_WOODWORKING
end
end
_("Bag/slot ("..r..","..t..") Skill ("..n..") "..tostring(c[n]))if n~=0 then
local r=GetItemTrait(r,t)local t=F[r]if t~=nil then
_("Skill ("..n..") "..tostring(c[n]).." trait "..tostring(r).." index "..tostring(t).." research line "..tostring(o))for e,r in pairs(craft.db)do
if e~="_ignore"then
_("Char = "..tostring(e).." Track "..tostring(craft.db[e][c[n]].track).." Known "..craft.db[e][c[n]].trait[o][t])if craft.db[e][c[n]].track then
local n=craft.db[e][c[n]].trait[o][t]if n==0 then
_(e.." needs to research")table.insert(l,e)elseif n==1 then
_(e.." knows trait")table.insert(i,e)elseif n==2 then
_(e.." researching trait")table.insert(i,e.." (R)")end
end
end
end
else
_("Skill ("..n..") "..tostring(c[n]).." trait "..tostring(r).." not researchable")end
end
until true
return i,l
end
local function y(o,e,n,d,o,a)if e~=BAG_WORN and e~=BAG_BACKPACK and e~=BAG_BANK then
return
end
if a~=INVENTORY_UPDATE_REASON_DEFAULT then
return
end
local o=m(zo_strformat(SI_TOOLTIP_ITEM_NAME,GetItemName(e,n)))local a=" loc("..e..","..n.."), reason "..a
local l={GetItemInfo(e,n)}local E=GetItemLink(e,n,LINK_STYLE_DEFAULT)if(d)then
a=a.." new item"else
a=a.." item changed"end
if l[2]~=0 then
if d then
t("["..GetItemLink(e,n,LINK_STYLE_DEFAULT).."]"..a)else
_("["..GetItemLink(e,n,LINK_STYLE_DEFAULT).."]"..a)end
else
_("empty:"..a)end
p(e,n)if CanSmithingWeaponPatternsBeCraftedHere()or CanSmithingApparelPatternsBeCraftedHere()or CanSmithingSetPatternsBeCraftedHere()then
return
end
if(d)then
local a=false
local d=l[2]local d=l[7]local E=l[8]local l=GetItemType(e,n)local T,_=D(e,n)if#_>0 then
t("researchable: "..o)return
end
if R and(d>ITEMSTYLE_RACIAL_KHAJIIT
and d~=ITEMSTYLE_RACIAL_IMPERIAL)then
t("rare style: ("..tostring(d)..") "..o)return
end
if u then
local e=GetItemTrait(e,n)if(l==ITEMTYPE_ARMOR and e==ITEM_TRAIT_TYPE_ARMOR_INTRICATE)or(l==ITEMTYPE_WEAPON and e==ITEM_TRAIT_TYPE_WEAPON_INTRICATE)then
t("intricate: "..o)return
end
end
if i.db[o]~=nil and i.db[o][r]~=nil then
if not IsItemJunk(e,n)then
t("previously marked junk: "..o)a=true
end
end
if not a and h and l==ITEMTYPE_TRASH then
t("new trash junk: "..o)a=true
end
if not a and N and l==ITEMTYPE_LURE then
t("new lure junk: "..o)a=true
end
if not a and l==ITEMTYPE_TROPHY
and E<O then
t("new trophy junk: "..o)a=true
end
if not a and(l==ITEMTYPE_ARMOR or l==ITEMTYPE_WEAPON)then
if E<I then
t("new armor/weap junk below threshold: "..o)a=true
end
end
if a then
SetItemIsJunk(e,n,true)G(e,n)end
else
if IsItemJunk(e,n)then
G(e,n)else
if(i.db[o]~=nil and i.db[o][r]~=nil)then
i.db[o][r]=nil
t("unmarking junk: "..o)end
end
end
end
local function p(r,t,n,e,r,r,r)if f~=nil and f then
d(m(t).." received "..m(n).." x "..e)end
end
local function G(o)local r
local e={}if o==""or o==nil then
d(k..n.usage)else
for n in string.gmatch(o,"%a+")do
table.insert(e,n)end
r=e[1]t("CLI: "..r.." "..tostring(e[2]).." "..tostring(e[3]))if E[r]==nil then
d(k..n.usage)else
E[r](e)end
end
end
E={["default"]=function()for n,e in pairs(P)do
o[n]=e
end
C()end,["status"]=function()d(T..": "..n.showloot.."="..tostring(f))d(T..": "..n.gray.."="..tostring(h))d(T..": "..n.lure.."="..tostring(N))d(T..": "..n.rarestyles.."="..tostring(R))d(T..": "..n.intricate.."="..tostring(u))d(T..": "..n.trophy.."="..tostring(O))d(T..": "..n.debug.."="..tostring(s))end,["debug"]=function()s=math.fmod(s+1,3)d(T..": "..n.debug.."="..tostring(s))Y()end,["db"]=function()local t=false
local e=""for i,o in pairs(i.db)do
if type(o)=="table"and o[r]then
if not t then
d(n.char..r)e=i
t=true
else
e=e..", "..m(i)end
end
end
if not t then
d(n.notfound..r)else
d(e)end
end,["reset"]=function()_("db before reset")_(i.db)for n,e in pairs(i.db)do
if type(e)=="table"then
i.db[n]={}end
end
d(n.cleared)_("db after reset")_(i.db)end,["resetall"]=function()i.db={}craft.db={["_ignore"]={},}inv.db={["_bank"]={},}t("all databases cleared")end,["loot"]=function()f=not f
M(f,n.showloot)Y()end,["gray"]=function()h=not h
M(h,n.gray)Y()end,["rarestyles"]=function()R=not R
M(R,n.rarestyles)Y()end,["intricate"]=function()u=not u
M(u,n.intricate)Y()end,["lure"]=function()N=not N
M(N,n.lure)Y()end,["green"]=function()I=ITEM_QUALITY_MAGIC
end,["blue"]=function()I=ITEM_QUALITY_ARCANE
end,["purple"]=function()I=ITEM_QUALITY_ARTIFACT
end,["white"]=function()I=ITEM_QUALITY_NORMAL
end,}E["grey"]=E["gray"]E["trash"]=E["gray"]E["showloot"]=E["loot"]E["rare"]=E["rarestyles"]local function d()for a,o in pairs(c)do
local e=GetNumSmithingResearchLines(a)_(o.." "..tostring(e))for e=1,e do
craft.db[r][o].trait[e]={0,0,0,0,0,0,0,0}for n=1,8 do
local l,d,i=GetSmithingResearchLineTraitInfo(a,e,n)local l=false
if not i then
local n,r=GetSmithingResearchLineTraitTimes(a,e,n)if n~=nil then
t(tostring(e).." "..d.." researching")l=true
end
else
_(tostring(e).." "..d.." "..tostring(i))end
if i then
craft.db[r][o].trait[e][n]=1
elseif l then
craft.db[r][o].trait[e][n]=2
end
end
end
end
end
local function _(r,i,o)local e,n,t=ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB()r:AddLine("")if#i>0 then
r:AddLine("Trait Known by","ZoFontWinH5",e,n,t,BOTTOM,MODIFY_TEXT_TYPE_UPPERCASE)for i,o in pairs(i)do
r:AddLine(o,"ZoFontWinH5",e,n,t)end
end
if#o>0 then
e,n,t=.3,.3,.8
r:AddLine("Trait Researchable by","ZoFontWinH5",e,n,t,BOTTOM,MODIFY_TEXT_TYPE_UPPERCASE)for i,o in pairs(o)do
r:AddLine(o,"ZoFontWinH5",e,n,t)end
end
end
function g:Ni_loot_tooltip(e,n,...)self.old_loot_tooltip(e,n,...)end
function g:Ni_tooltip(n,o,e,...)local t,r=D(o,e)self.old_tooltip(n,o,e,...)if#t==0 and#r==0 then
return
end
_(n,t,r)end
local function Y(e,t,n,...)g:Ni_tooltip(e,t,n,...)end
local function M(n,e,...)g:Ni_loot_tooltip(n,e,...)end
local function T(r)EVENT_MANAGER:UnregisterForEvent(e,EVENT_PLAYER_ACTIVATED)t(e.." "..b.."."..U.." debug="..tostring(s))if S then
CHAT_SYSTEM:AddMessage(n.firstrun1)CHAT_SYSTEM:AddMessage(n.firstrun2)CHAT_SYSTEM:AddMessage(n.startup)end
v=true
end
function g:init()EVENT_MANAGER:UnregisterForEvent(e,EVENT_ADD_ON_LOADED)EVENT_MANAGER:RegisterForEvent(e,EVENT_LOOT_RECEIVED,p)EVENT_MANAGER:RegisterForEvent(e,EVENT_INVENTORY_SINGLE_SLOT_UPDATE,y)r=GetUnitName("player")local _=GetCVar("language.2")if L[_]~=nil then
n=L[_]else
n=L.en
end
o=ZO_SavedVars:New("Ni_IM",b,nil,P,"config")or{}C()i=ZO_SavedVars:NewAccountWide("Ni_IM",b,nil,{},"junk")or{}if i.db==nil then
i.db={}end
craft=ZO_SavedVars:NewAccountWide("Ni_IM",b,nil,nil,"craft")or{}if craft.db==nil then
craft.db={}S=true
end
if craft.db._ignore==nil then
craft.db._ignore={}end
inv=ZO_SavedVars:NewAccountWide("Ni_IM",b,nil,nil,"inventory")or{}SLASH_COMMANDS[W]=G
l=a:CreateControlPanel(e,"Ni Inventory")a:AddHeader(l,e.."H1","Options")a:AddCheckbox(l,e.."loot","Show loot","Show all loot collected, including by party members\n/nim loot",function()return f end,E["loot"],false,nil)a:AddHeader(l,e.."H2","Autojunk rules:")a:AddDropdown(l,e.."keep","Keep threshold","Autojunk armor & weapons under this quality\ndefault: "..A[P.keep],A,function()return A[I]end,function(n)t("set threshold to "..n)for e,r in ipairs(A)do
if A[e]==n then I=e break end
end t("keep threshold: "..A[I])end,false,nil)a:AddDropdown(l,e.."trophy","Trophy threshold","Autojunk trophies under this quality\ndefault: "..A[P.trophy],A,function()return A[O]end,function(e)t("set threshold to "..e)for n,r in ipairs(A)do
if A[n]==e then O=n break end
end t("trophy threshold: "..A[O])end,false,nil)a:AddCheckbox(l,e.."rarestyles","Keep Rare Styles","Never autojunk rare styles (e.g. Daedric, for recovery of style components)\n/nim rarestyles\ndefault: "..tostring(P.rarestyles),function()return R end,E["rarestyles"],false,nil)a:AddCheckbox(l,e.."intricate","Keep Intricate Items","Never autojunk intricate items (for inspiration gains)\n/nim intricate\ndefault: "..tostring(P.intricate),function()return u end,E["intricate"],false,nil)a:AddCheckbox(l,e.."trash","Autojunk Trash","Autojunk all gray items whether or not previously junked\n/nim gray\ndefault: "..tostring(P.gray),function()return h end,E["gray"],false,nil)a:AddCheckbox(l,"lure","Autojunk Lures","Autojunk fishing bait\n/nim lure\ndefault: "..tostring(P.lure),function()return N end,E["lure"],false,nil)if craft.db[r]==nil then
craft.db[r]={[c[CRAFTING_TYPE_BLACKSMITHING]]={["track"]=false,["trait"]={}},[c[CRAFTING_TYPE_WOODWORKING]]={["track"]=false,["trait"]={}},[c[CRAFTING_TYPE_CLOTHIER]]={["track"]=false,["trait"]={}},}end
d()a:AddHeader(l,e.."traits","Trait Tracking")for e in pairs(craft.db)do
if e~="_ignore"and craft.db._ignore[e]and craft.db[e]~=nil then
craft.db[e]=nil
end
end
for n in pairs(craft.db)do
if n~="_ignore"then
if craft.db._ignore[n]==nil then
craft.db._ignore[n]=false
end
if not craft.db._ignore[n]then
a:AddHeader(l,e..n,n)for r,t in pairs(c)do
a:AddCheckbox(l,e..n..t,t,"Track items with unknown "..t.." traits for this character".." and don't auto-junk (on any character)",function()if craft.db[n][t].track==nil
then craft.db[n][t].track=false end
return craft.db[n][t].track end,function()craft.db[n][t].track=not craft.db[n][t].track
end,false,nil)end
a:AddCheckbox(l,e.."ignore"..n,"Ignore this character","Permanently ignore this character name (even if recreated). ".."(Use to clear deleted characters and non-crafters)",function()return craft.db._ignore[n]end,function()craft.db._ignore[n]=not craft.db._ignore[n]end,true,"Takes effect after relog\nUse '/nim resetall' for factory reset.")end
end
end
ZO_PreHook("ZO_OptionsWindow_ChangePanels",function(e)if(e==PanelId)then
ZO_OptionsWindowResetToDefaultButton:SetCallback(E.default)end
end)if inv.db==nil then
inv.db={}end
if inv.db._bank==nil then
inv.db._bank={}end
if inv.db[r]==nil
or inv.db[r][BAG_WORN]==nil
or inv.db[r][BAG_BACKPACK]==nil then
inv.db[r]={[BAG_WORN]={},[BAG_BACKPACK]={}}end
inv.db[r].track=true
H()a:AddHeader(l,e.."inven","Inventory Tracking")for n in pairs(inv.db)do
if n~="_bank"then
if inv.db[n].track then
a:AddCheckbox(l,e.."inv"..n,n,"Track inventory of this character",function()return inv.db[n].track end,function()inv.db[n].track=not inv.db[n].track
if not inv.db[n].track then
inv.db[n][BAG_WORN]=nil inv.db[n][BAG_BACKPACK]={}end end,true,"Turn OFF to immediately clear saved inventory.".."\nAutomatically enabled at character login.")end
end
end
a:AddDescription(l,e.."desc",[[NIM tracks inventories and known crafting traits of all characters, and autojunks items based on user criteria or previously marking as junk.

Use "/nim" for command line interface.

Official download and list of legitimate mirrors at
http://knights-who-say-ni.com/ESO]],"Ni Inventory Monitor Ver "..tostring(b).."."..tostring(U))self.old_tooltip=ItemTooltip.SetBagItem
ItemTooltip.SetBagItem=Y
self.old_loot_tooltip=ItemTooltip.SetLootItem
ItemTooltip.SetLootItem=M
end
local function t(t,n)if n~=e then
return
end
g:init()EVENT_MANAGER:RegisterForEvent(e,EVENT_PLAYER_ACTIVATED,T)EVENT_MANAGER:RegisterForEvent(e,EVENT_SMITHING_TRAIT_RESEARCH_STARTED,d)EVENT_MANAGER:RegisterForEvent(e,EVENT_SMITHING_TRAIT_RESEARCH_COMPLETED,d)end
EVENT_MANAGER:RegisterForEvent(e,EVENT_ADD_ON_LOADED,t)